﻿<?php
/*
Plugin Name: WP-Cumulus
Plugin URI: http://www.roytanck.com
Description: Плагин выводит облако тегов с использованием флеша. Русифицировал <a href="http://absolvo.ru/">Волотко Дмитрий</a>.
Version: 1.02r
Author: Roy tanck
Author URI: http://www.roytanck.com
*/

//initially set the options
function wp_cumulus_install () {
	update_option('cumulus_width', '600');
	update_option('cumulus_height', '450');
	update_option('cumulus_textcolor', 'ffffff');
	update_option('cumulus_backcolor', '333333');
	update_option('cumulus_transparent', 'false');
	update_option('cumulus_insertswfobject', 'true');
}

// add the admin page
function wp_cumulus_add_pages() {
	add_options_page('WP Cumulus', 'WP Cumulus', 8, __FILE__, 'wp_cumulus_options');
}

// replace tag in content with tag cloud
function wp_cumulus_init($content){
	if( strpos($content, '[WP-CUMULUS]') === false ){
		return $content;
	} else {
		$code = wp_cumulus_createflashcode();
		$content = str_replace( '[WP-CUMULUS]', $code, $content );
		return $content;
	}
}

// template function
function wp_cumulus_insert(){
	echo wp_cumulus_createflashcode();
}

// piece together the flash code
function wp_cumulus_createflashcode(){
	// get the tag cloud...
	ob_start();
	wp_tag_cloud('');
	$tagcloud = urlencode( str_replace( "&nbsp;", " ", ob_get_clean() ) );
	ob_end_clean();
	// create the flash tags
	$movie = get_bloginfo('url') . "/wp-content/plugins/wp-cumulus/tagcloud.swf";	
	$flashtag = '<div id="tagcloudflash">'.urldecode($tagcloud).'<p>WP Cumulus Flash tag cloud by <a href="http://www.roytanck.com">Roy Tanck</a> requires Flash Player 7 or better.</p></div>';
	$flashtag .= '<script type="text/javascript">';
	//$flashtag .= '// <![CDATA[';
	$flashtag .= 'var so = new SWFObject("'.$movie.'", "tagcloudflash", "'.get_option('cumulus_width').'", "'.get_option('cumulus_height').'", "7", "#'.get_option('cumulus_backcolor').'");';
	if( get_option('cumulus_transparent') == 'true' ){
		$flashtag .= 'so.addParam("wmode", "transparent");';
	}
	$flashtag .= 'so.addVariable("tcolor", "0x'.get_option('cumulus_textcolor').'");';
	$flashtag .= 'so.addVariable("tagcloud", "<tags>'.$tagcloud.'</tags>");';
	$flashtag .= 'so.write("tagcloudflash");';
	//$flashtag .= '// ]]>';
	$flashtag .= '</script>';
	return $flashtag;
}

// function to display the options page
function wp_cumulus_options() {
	global $table_prefix, $wpdb;	
	// if options form was sent, process those...
	if( $_GET['action'] == "updateoptions" ){
		update_option('cumulus_width', $_POST['cumulus_width']);
		update_option('cumulus_height', $_POST['cumulus_height']);
		update_option('cumulus_textcolor', $_POST['cumulus_textcolor']);
		update_option('cumulus_backcolor', $_POST['cumulus_backcolor']);
		update_option('cumulus_transparent', $_POST['cumulus_transparent']);
		update_option('cumulus_insertswfobject', $_POST['cumulus_insertswfobject']);
	}
	// options form
	echo "<div class=\"wrap\"><p><h2>Плагин WP Cumulus : настойки</h2><p>";
	echo '<form method="post" action="'.get_bloginfo('wpurl').'/wp-admin/options-general.php?page=wp-cumulus/wp-cumulus.php&action=updateoptions">';
	// settings
	echo '<fieldset class="options"><legend>Настройте отображение облака тегов.</legend><table class="editform optiontable">';
	// width
	echo '<tr valign="top"><th scope="row">Ширина облака тегов</th>';
	echo '<td><input type="text" name="cumulus_width" value="'.get_option('cumulus_width').'" size="5"></input><br />Ширина в пикселях (рекомендуется от 500px)</td></tr>';
	// height
	echo '<tr valign="top"><th scope="row">Высота облака тегов</th>';
	echo '<td><input type="text" name="cumulus_height" value="'.get_option('cumulus_height').'" size="5"></input><br />Высота в пикселях (идеальный вариант - соотношение 3/4 к ширине)</td></tr>';
	// text color
	echo '<tr valign="top"><th scope="row">Цвет тегов</th>';
	echo '<td><input type="text" name="cumulus_textcolor" value="'.get_option('cumulus_textcolor').'" size="8"></input><br />Укажите hex-значение цвета без # (000000 для чёрного или ffffff для белого)</td></tr>';
	// background color
	echo '<tr valign="top"><th scope="row">Цвет фона</th>';
	echo '<td><input type="text" name="cumulus_backcolor" value="'.get_option('cumulus_backcolor').'" size="8"></input><br />Укажите hex-значение цвета без #</td></tr>';
	// transparent
	echo '<tr valign="top"><th scope="row">Использовать прозрачный фон</th>';
	echo '<td><input type="checkbox" name="cumulus_transparent" value="true"';
	if( get_option('cumulus_transparent') == true ){ echo ' checked="checked"'; }
	echo '></input><br />Если поставить галочку, то у облака тегов будет прозрачный фон</td></tr>';
	// SWFObject
	echo '<tr valign="top"><th scope="row">Использовать SWFObject</th>';
	echo '<td><input type="checkbox" name="cumulus_insertswfobject" value="true"';
	if( get_option('cumulus_insertswfobject') == true ){ echo ' checked="checked"'; }
	echo '></input><br />Снимите галочку, если вы уже используете SWFObject (к примеру с любым другим плагином). Вы можете проверить это, посмотрев исходный код любой вашей страницы. SWFObject должен быть внутри тега header.</td></tr>';
	echo '</table></fieldset>';
	echo '<p class="submit"><input type="submit" value="Обновить настройки &raquo;"></input></p>';
	echo '</form>';
	echo "</div>";
}

function wp_cumulus_head(){
	if( get_option('cumulus_insertswfobject') == true ){
		$path = get_bloginfo('url')."/wp-content/plugins/wp-cumulus/";
		echo '<!-- SWFObject embed by Geoff Stearns geoff@deconcept.com http://blog.deconcept.com/swfobject/ -->';
		echo '<script type="text/javascript" src="'.$path.'swfobject.js"></script>';
	}
}

//initially set the options
function wp_cumulus_uninstall () {
	delete_option('cumulus_width');
	delete_option('cumulus_height');
	delete_option('cumulus_textcolor');
	delete_option('cumulus_backcolor');
	delete_option('cumulus_transparent');
	delete_option('cumulus_insertswfobject');
}

// add the actions
add_action('admin_menu', 'wp_cumulus_add_pages');
add_action('wp_head', 'wp_cumulus_head');
add_filter('the_content','wp_cumulus_init');
register_activation_hook( __FILE__, 'wp_cumulus_install' );
register_deactivation_hook( __FILE__, 'wp_cumulus_uninstall' );
?>